<?php

// auth.inc.php - PHProjekt Version 4.0
// copyright    2000-2003 Albrecht Guenther  ag@phprojekt.com
// www.phprojekt.com
// Author: Albrecht Guenther

// check whether lib.inc.php has been included
if (!defined("lib_included")) { die("Please use index.php!"); }

$fetch_uservalues = 0;

// fetch language ...
$lang_found = 0;
$langua = getenv("HTTP_ACCEPT_LANGUAGE");
foreach($languages as $langua1) { 
  if (eregi($langua1,$langua)) { 
    $langua = $langua1; 
    $lang_found = 1; 
  } 
}
if ($lang_found) { include_once("$lang_path/$langua.inc.php"); }
else { $langua = "en"; include_once("$lang_path/en.inc.php"); }
// fetch skin and style ...
if(!$css_style){
  $skin = "default";
  $css_style = def_style(); 
}

// check for the appropiate login field ...
if (!$login_kurz) {
  $label = $index_text1a;
  $field_name = "nachname";
}
elseif ($login_kurz == "1") {
  $label = $index_text1c;
  $field_name = "kurz";
}
elseif (($login_kurz == "2") || ($ldap == "1")) {
  $label=$admin_text83;
  $field_name="loginname";
}


// no values from the session or the login form?-> show login form
if (!$user_pw and !$user_name) {
  echo "<html><head><link rel=stylesheet type='text/css' href='$css_style'></head>";
  // see whether a welcome screen exists
  if (is_file("$img_path/welcome.jpg")) { $background = "background='$img_path/welcome.jpg'"; }
  // if not, put the logo above
  else { $logo_img = "$img_path/logo.gif"; }
  // show form
  include_once("$lib_path/authform.inc.php");
  exit;
}

// values exist -> check authentication
else {
  // add additional condition if logged to the admin section
  if ($file == "admin") { $admin_login = "and acc like '%a%'"; }
  else { $admin_login = ""; }

  // use ldap?
  if ($ldap == "1"){
    $includefile4 = $lib_path . "/ldap_auth.inc.php";
    include_once $includefile4;
  }
  // normal authentication system
  else {
    $result = db_query("select * from users where $field_name = '$loginstring' $admin_login");
    // loop through all names in the table users and check password
    while ($row = db_fetch_row($result)) {
      // check for password encryption and if yes, crypt the value from the form
      if ($pw_crypt) {
        $includefile5 = $path_pre."lib/crypt.inc.php";
        include_once $includefile5;
        $enc_pw = encrypt($user_pw, $row[4]);
      }
      // just the unencrypted password
      else { $enc_pw = $user_pw; }
      
      // great! I found an entry for you!
      if ($row[4] == $enc_pw) {
        // store the found user_ID
        $fetch_uservalues = $row[0];
      } // end check for &pw
    } // end loop over all found users with the same loginstring
  } // end case for non-ldap auth

  // track the login
  if ($logs and !$logID and $user_ID) {
    $result2 = db_query("insert into logs values($dbIDnull,$user_ID,$dbTSnull,null)") or db_die();
    // store logID for the logout
    $result2 = db_query("select ID from logs where von = '$user_ID' and login = '$dbTSnull'") or db_die();
    $row2 = db_fetch_row($result2);
    $logID = $row2[0];
  }

} // end else bracket for authentication

    
// no record found? -> display error message
if (!$fetch_uservalues) {
  // destroy the session - on some system the first, on some system the second function doesn't work :-))
  @session_unset();
  @session_destroy();
  die("<html><head><link rel=stylesheet type='text/css' href='$css_style'></head>
       <body>$index_text2! <br><a href='index.php'>$back</a> ...</body></html>");
}

// fetch the user values and stroe them in the session!
else { 
  // fetch the data ...
  $result = db_query("select * from users where ID = '$fetch_uservalues'") or db_die();
  $row = db_fetch_row($result);  
  // fill the user data into variables  
  $user_ID = $row[0];
  $user_firstname = $row[1];
  $user_name = $row[2];
  $user_email = $row[7];
  $user_kurz = $row[3];
  $user_loginname = $row[18];
  $user_smsnr = $row[21];  //sms nr
  // Take the default group from the data set unless the user has chosen another one during the session
  if (!$user_group) { $user_group = $row[6] + 0; }
  // fetch settings
  $settings = unserialize($row[24]);
  if ($settings) { 
    foreach($settings as $key => $value) { $$key = $value; } 
  }
  // fetch access: first character is for the user status, second one for the visibility of his calendar
  $user_access = $row[8];
  // have a look into the group table: maybe he's the leader of the group _-> declare him as chief ;-)
  if ($groups and $user_group > 0) {
    $result2 = db_query("select chef from gruppen where ID = '$user_group'") or db_die();
    $row2 = db_fetch_row($result2);
    if ($row2[0] == $user_ID) { $user_access = "c".substr($user_access,0,1); }
  }

  // set language and load language only if language is set in the db and differs from the actual value
  if (!$langua and $row[16] <> "" and $row[16] <> $langua) {
    include_once("$lang_path/$row[16].inc.php"); $langua = "$row[16]";
  }

  // unset array $row
  unset ($row);

  // register user variables in session
  reg_sess_vars(array("user_ID","user_name","user_firstname","user_pw","user_group","user_kurz","user_access",
                      "user_loginname","user_email","langua","loginstring","logID","user_smsnr"));
}
?>
