<?php

// projects_data.php - PHProjekt Version 4.0
// copyright    2000-2003 Albrecht Guenther  ag@phprojekt.com
// www.phprojekt.com
// Author: Albrecht Guenther

// check whether the lib has been included - authentication!
if (!defined("lib_included")) { die("Please use index.php!"); }

// check role
if (check_role("projects") < 2) { die("You are not allowed to do this!"); }

function delete_project() {
  global $ID, $admin_text47, $admin_text48, $admin_text49, $back, $img_path, $user_access;

  // check permission if you don't have chef level
  if (!ereg("c",$user_access)) {
    check_permission_leader("projekte","chef",$ID);
  }

  if (!$ID) { die("$admin_text47! <br><a href='projects.php?".SID."'>$back</a>"); }
  // fetch project name
  $result = db_query("select name from projekte where ID = '$ID'") or db_die();
  $row = db_fetch_row($result);
  // delete project and show message
  $result = db_query("delete from projekte where ID = '$ID'") or db_die();
  echo "$row[0] - $admin_text48.<br>";
  // free events from project link
  $result = db_query("update termine set projekt = '' where projekt = '$ID'") or db_die();
  echo "$admin_text49<br>\n";
  // free files from project link
  $result = db_query("update dateien set div2 = '' where div2 = '$ID'") or db_die();
  // free notes from project link
  $result = db_query("update notes set projekt = '' where projekt = '$ID'") or db_die();

  echo "<img src='$img_path/s.gif' width=300 height=1 vspace=2 border=0>";
}

function check_anlegen() {
  global $ende, $anfang, $admin_text50, $sid, $ID, $anfang, $ende, $wichtung, $back, $project_name, $action, $error,
         $chef, $note, $contact, $stundensatz, $budget, $proj_text14, $m1_text4, $parent, $img_path, $proj_text31;

  // check if end time is bigger than start time
  if ($ende < $anfang) { die("$admin_text50! <br><a href='projects.php?mode=forms&ID=$ID&project_name=$project_name&anfang=$anfang&ende=$ende&wichtung=$wichtung&chef=$chef&parent=$parent&note=$note&contact=$contact&stundensatz=$stundensatz&budget=$budget$sid'>$back</a> ");}
  // if given, check whether budget and hourly rates are integer
  if ($budget <> "" and !is_numeric($budget))  { die("$proj_text14: $m1_text4! <br><a href='projects.php?mode=forms&action=$action&ID=$ID&project_name=$project_name&anfang=$anfang&ende=$ende&wichtung=$wichtung&chef=$chef&parent=$parent&note=$note&contact=$contact&stundensatz=$stundensatz&budget=$budget$sid'>$back</a> "); }
  if ($stundensatz <> "" and !is_numeric($stundensatz))  { die("$proj_text14: $m1_text4! <br><a href='projects.php?mode=forms&action=$action&ID=$ID&project_name=$project_name&anfang=$anfang&ende=$ende&wichtung=$wichtung&chef=$chef&parent=$parent&note=$note&contact=$contact&stundensatz=$stundensatz&budget=$budget$sid'>$back</a> "); }

  // assign an explicit value to $parent
  if (!$parent) { $parent = "0"; }

  else {
    // the project is subproject? check whether the start and end time is within the limits of the parent project
    $result2 = db_query("select anfang, ende from projekte where ID = '$parent'") or db_die();
    $row2 = db_fetch_row($result2);
    // timespan exceeds timespan of parent -> die ...
    if ($anfang < $row2[0] or $ende > $row2[1]) {
     die("$proj_text31<br><a href='projects.php?mode=forms&action=$action&ID=$ID&project_name=$project_name&anfang=$anfang&ende=$ende&wichtung=$wichtung&chef=$chef&parent=$parent&note=$note&contact=$contact&stundensatz=$stundensatz&budget=$budget&ziel=$ziel&note=$note$sid'>$back</a>\n");
    }
  }
  
  // check dependencies
  if ($depend_mode > 1) { $error = check_dependencies($ID, $depend_mode, $depend_proj, $cat, $project_name, $anfang, $ende); }
}

function insert_project() {
  global $parent, $project_name, $sid, $back, $dbIDnull, $ende, $personen, $wichtung, $anfang, $admin_text73, $stundensatz,
         $user_group, $chef, $parent, $ziel, $note, $cat, $contact, $budget, $admin_text51, $img_path;

  $personen2 = serialize($personen);
  // assign a value to $parent explicitely if it's on the root level
  if (!$parent) $parent = "0";
  // no project name given?
  if (!$project_name) { die("$admin_text73! <br><a href='projects.php?mode=forms&action=new$sid'>$back</a> "); }
  // finally: the db action
  $result = db_query("insert into projekte values($dbIDnull,'$project_name','$ende','$personen2','$wichtung',null,null,'$anfang','$user_group','$chef',null,'$parent','$ziel','$note',$cat,'$contact','$stundensatz','$budget',null,null,null,null,null,null)") or db_die();
  // message: prpject inserted
  echo "$project_name: $admin_text51.<br>\n";
  echo "<img src='$img_path/s.gif' width=300 height=1 vspace=2 border=0>";
}

function update_project() {
  global $parent, $project_name, $ende, $personen, $wichtung, $anfang, $admin_text52,  $user_access, $stundensatz,
         $user_group, $chef, $parent, $ziel, $note, $cat, $contact, $budget, $admin_text73, $img_path, $ID, 
         $depend_mode, $depend_proj, $next_mode, $next_proj, $error;

  // check permission if you don't have chef level
  if (!ereg("c",$user_access)) { check_permission("projekte","chef",$ID); }
  
  // check whether the subproject has changed the parent and resides in a new branch - 
  // in this case the next/previous entry and the dependency will be deleted
  $result3 = db_query("select parent from projekte where ID = '$ID'") or db_die();
  $row3 = db_fetch_row($result3);
  if ($parent <> $row3[0]) {
    $depend_mode = ""; $depend_proj = "";
    $next_mode = ""; $next_proj = "";
    // but also: scan for projects which have this project as next or dependency and delete this relations
    $result4 = db_query("update projekte set depend_proj='', depend_mode='' where depend_proj = '$ID'") or db_die();
    $result4 = db_query("update projekte set next_proj='', next_mode='' where next_proj = '$ID'") or db_die(); 
  }
  
  if (!$error) {
    $personen2 = serialize($personen);
    if (!$project_name) { die("$admin_text73! <br><a href='projects.php?mode=forms&action=aendern&ID=$ID$sid'>$back</a>");}
    $result = db_query("update projekte set name='$project_name',
                                            kategorie='$cat',
                                            ende='$ende',
                                            personen='$personen2',
                                            wichtung='$wichtung', 
                                            anfang='$anfang',
                                            gruppe='$user_group',
                                            chef='$chef',
                                            parent='$parent',
                                            ziel='$ziel',
                                            note='$note',
                                            contact='$contact',
                                            stundensatz='$stundensatz',
                                            budget='$budget',
                                            depend_mode = '$depend_mode', 
                                            depend_proj = '$depend_proj',
                                            next_mode = '$next_mode',
                                            next_proj = '$next_proj'  
                                            where ID = '$ID'") or db_die();
    echo "$project_name: $admin_text52.<br>\n";
    echo "<img src='$img_path/s.gif' width=300 height=1 vspace=2 border=0>";
  }  
}

// update status of project
function change_status() {
  global $status2, $r_status, $ID;

  // check permission if you don't have chef level
  if (!ereg("c",$user_access)) { check_permission("projekte","chef",$ID); }
  $heute = date( "Y-m-d");
  // if the status is not between 0 and 100% or not a number -> forget it
  if (!is_numeric($status2) or $status2 < 0 or $status2 > 100) { echo "$r_status"; }
  else {$result = db_query("update projekte set status='$status2', statuseintrag='$heute' where ID='$ID'") or db_die();}
}

// check permission
// this function is a bit different from the one in the lib:
// - it checks whether a chef has been chosen.
// - if yes, it looks for the short name of the project leader
function check_permission($table,$author,$ID) {
  global $user_kurz;
  $result = db_query("select $author from $table where ID = '$ID'") or db_die();
  $row = db_fetch_row($result);
  if ($row[0] <> "" and $row[0] <> $user_kurz) { die("You are not privileged to do this!"); }
}

// check permission - if not chief, is he/she the leader of this project?
function check_permission_leader($table,$author,$ID) {
  global $user_kurz;
  $result = db_query("select $author from $table where ID = '$ID'") or db_die();
  $row = db_fetch_row($result);
  if ($row[0] and $row[0] <> $user_kurz) { die("You are not privileged to do this!"); }
}

function check_dependencies($ID, $depend_mode, $depend_proj, $cat, $project_name, $anfang, $ende) {
  global $proj_text40, $dependencies, $categories;
  
  // fetch start and end date of the target project
  $result = db_query("select anfang, ende, kategorie, name from projekte where ID = '$depend_proj'") or db_die();
  $row = db_fetch_row($result);
  
  switch ($depend_mode) {
  
    // repeat the categiories here for those who don't want to have a look into the other skript:
    // 1=offered, 2=ordered, 3=at work, 4=ended, 5=stopped, 6=reopened 7 = waiting, 10=container, 11=ext. project    
    // start means 'at work' or higher, but not 'waiting'
    // end means 'ended' or 'stopped'
    
    // 2 = this project cannot start before the end of project B
    case "2":
      // check logical
      if (($cat > "2" and $cat <> 7) and ($row[2] <> "4" and $row[2] <> "5")) {
        echo "<h4>$proj_text40: $project_name \"$dependencies[$depend_mode] $row[3]\"<br>($row[3] = ".$categories[$row[2]].")</h4>";
        $error = 1;
      } 
      // check timeframe
      if ($anfang < $row[1]) { echo "$proj_text40: $proj_start($$project_name) < $proj_end($row[3]"; }
      break;      
    // 3 = this project cannot start before start of project B  
    case "3":
      if (($cat > "2" and $cat <> 7) and ($row[2] <= "2" or $row[2] == 7)) {
        echo "<h4>$proj_text40: $project_name \"$dependencies[$depend_mode] $row[3]\"<br>($row[3] = ".$categories[$row[2]].")</h4>";
        $error = 1;
      } 
      // check timeframe
      if ($anfang < $row[0]) { echo "$proj_text40: $proj_start($$project_name) < $proj_start($row[3]"; }
      break;            
    // 4 = this project cannot end before start of project B  
    case "4":
      if (($cat == "4" or $cat == "5") and ($row[2] <= "2" or $row[2] == 7)) {
        echo "<h4>$proj_text40: $project_name \"$dependencies[$depend_mode] $row[3]\"<br>($row[3] = ".$categories[$row[2]].")</h4>";
        $error = 1;
      }  
      // check timeframe
      if ($ende < $row[0]) { echo "$proj_text40: $proj_end($$project_name) < $proj_start($row[3]"; }        
      break;
    // 5 = this project cannot end before end of project B 
    case "5":
      if (($cat == "4" or $cat == "5")  and ($row[2] <> "4" and $row[2] <> "5")) {
        echo "<h4>$proj_text40: $project_name \"$dependencies[$depend_mode] $row[3]\"<br>($row[3] = ".$categories[$row[2]].")</h4>";
        $error = 1;
      }  
      // check timeframe
      if ($ende < $row[1]) { echo "$proj_text40: $proj_end($$project_name) < $proj_end($row[3]"; }   
      break;  
    }      
  return $error;
}



// *******
// actions
// *******

// change status
if ($change_status) { change_status(); }

// delete a project
if ($delete) { delete_project(); }

// create or modify a project
elseif ($anlegen) {
  // first check some values ...
  check_anlegen();
  // ... now the db action
  if ($anlegen == "neu_anlegen") { insert_project(); }
  elseif ($anlegen == "aendern") { update_project(); }
}

// if error, go back to the form
if ($error > 0) {
  include_once("./projects_forms.php");
}
else {
  // show list of projects
  include_once("./projects_view.php");
}

?>